﻿let FWEditor = (function() {
	let version = "0.21";
	let lastupdate = "2017/10/10";
	let idcount = 0;
	let Sqsize = 16;
	let Maxwidth = 100;
	let Maxheight = 100;
	let Defaultwidth = 20;
	let Defaultheight = 20;
	let Terrain_UI_width = 30;

	let Toolwidth = 260;
	let Toolheight = 350;

	let Country = [ 
		{ fname: "no", npc: true },
		{ fname: "rs" },
		{ fname: "bm" },
		{ fname: "ge" },
		{ fname: "yc" },
		{ fname: "bh" },
	];
	let Countrynamenum = {
		"rs": 0,
		"bm": 1,
		"ge": 2,
		"yc": 3,
		"bh": 4,
	};

	let Terrain_imglist = {
		plain:			{ land: true, receiveshadow: true, imgdata: { num: 0, ix: 1, iy :0, sx: 3, sy: 1, height: 16 } },
		plain_pd:		{ land: true, pipe: true, connect: true, imgdata: { num: 0, ix: 4, iy :0, height: 16 } },
		wood:				{ land: true, receiveshadow: true, shadow: true, imgdata: { num: 1, ix: 1, iy: 0, sx: 2, sy: 0, height: 32 } },
		mountain:		{ land: true, shadow: true, imgdata: { num: 1, ix: 3, iy:0, height: 32 } },
		mountain2:	{ land: true, shadow: true, imgdata: { num: 1, ix: 0, iy:0, height: 32 } },
		mountain3:	{ land: true, shadow: true, imgdata: { num: 1, ix: 4, iy:0, height: 32 } },
		road:				{ land: true, connect: true, receiveshadow: true, imgdata: { num: 0, ix: 7, iy :3, height: 16 } },
		bridge:			{ connect: true, imgdata: { num: 0, ix: 21, iy: 0, height: 16 } },
		pipe:				{ land: true, pipe: true, connect: true, imgdata: { num: 0, ix: 3, iy: 11, height: 16 } },
		pipe_c:			{ land: true, pipe: true, connect: true, candestroy: true, hp: 99, imgdata: { num: 0, ix: 5, iy: 12, height: 16 } },
		river:			{ land: true, connect: true, imgdata: { num: 0, ix: 25, iy: 0, height: 16 } },
		sea:				{ sea: true, connect: true, imgdata: { num: 0, ix: 12, iy: 1, height: 16 } },
		reef:				{ sea: true, imgdata: { num: 0, ix: 11, iy: 12, height: 16 } },
		shoal:			{ sea: true, connect: true, imgdata: { num: 0, ix: 10, iy: 8, height: 16 } },
		missle:			{ land: true, shadow: true, imgdata: { num: 3, ix: 0, iy: 0, height: 32 } },
		misslenone:	{ land: true, shadow: true, imgdata: { num: 3, ix: 6, iy: 1, height: 16 } },
		wideriver:	{ land: true, connect: true, imgdata: { num: 0, ix: 1, iy :1, height: 16 } },
		road10:			{ land: true, receiveshadow: true, imgdata: { num: 0, ix:  7, iy : 3, sx: 11, sy: 5, height: 16 } },
		road5:			{ land: true, receiveshadow: true, imgdata: { num: 0, ix:  4, iy : 2, sx:  8, sy: 4, height: 16 } },
		road3:			{ land: true, receiveshadow: true, imgdata: { num: 0, ix:  6, iy : 3, sx: 10, sy: 5, height: 16 } },
		road6:			{ land: true, receiveshadow: true, imgdata: { num: 0, ix:  5, iy : 2, sx:  9, sy: 4, height: 16 } },
		road12:			{ land: true, receiveshadow: true, imgdata: { num: 0, ix:  6, iy : 2, sx: 10, sy: 4, height: 16 } },
		road9:			{ land: true, receiveshadow: true, imgdata: { num: 0, ix:  8, iy : 3, sx: 12, sy: 5, height: 16 } },
		road7:			{ land: true, receiveshadow: true, imgdata: { num: 0, ix: 26, iy : 7, sx: 28, sy: 7, height: 16 } },
		road14:			{ land: true, receiveshadow: true, imgdata: { num: 0, ix: 25, iy : 7, sx: 27, sy: 7, height: 16 } },
		road13:			{ land: true, receiveshadow: true, imgdata: { num: 0, ix: 23, iy : 6, sx: 25, sy: 6, height: 16 } },
		road11:			{ land: true, receiveshadow: true, imgdata: { num: 0, ix: 22, iy : 6, sx: 24, sy: 6, height: 16 } },
		road15:			{ land: true, receiveshadow: true, imgdata: { num: 0, ix: 27, iy : 8, sx: 28, sy: 8, height: 16 } },
		bridgeh:		{ imgdata: { num: 0, ix: 21, iy : 0, height: 16 } },
		bridgev:		{ imgdata: { num: 0, ix: 22, iy : 0, height: 16 } },
		pipe10:			{ land: true, pipe: true, imgdata: { num: 0, ix:  3, iy : 11, height: 16 } },
		pipe5:			{ land: true, pipe: true, imgdata: { num: 0, ix:  4, iy : 11, height: 16 } },
		pipe3:			{ land: true, pipe: true, imgdata: { num: 0, ix:  3, iy : 12, height: 16 } },
		pipe6:			{ land: true, pipe: true, imgdata: { num: 0, ix:  1, iy : 11, height: 16 } },
		pipe12:			{ land: true, pipe: true, imgdata: { num: 0, ix:  2, iy : 11, height: 16 } },
		pipe9:			{ land: true, pipe: true, imgdata: { num: 0, ix:  4, iy : 12, height: 16 } },
		pipe4:			{ land: true, pipe: true, imgdata: { num: 0, ix: 29, iy :  8, height: 16 } },
		pipe8:			{ land: true, pipe: true, imgdata: { num: 0, ix:  0, iy : 10, height: 16 } },
		pipe1:			{ land: true, pipe: true, imgdata: { num: 0, ix:  0, iy :  9, height: 16 } },
		pipe2:			{ land: true, pipe: true, imgdata: { num: 0, ix: 29, iy :  9, height: 16 } },
		pipe_cv:		{ land: true, pipe: true, imgdata: { num: 0, ix:  6, iy : 12, height: 16 }, candestroy: true, hp: 99 },
		pipe_ch:		{ land: true, pipe: true, imgdata: { num: 0, ix:  5, iy : 12, height: 16 }, candestroy: true, hp: 99 },
		plain_pdh:	{ land: true, pipe: true, imgdata: { num: 0, ix:  1, iy : 10, height: 16 } },
		plain_pdv:	{ land: true, pipe: true, imgdata: { num: 0, ix:  2, iy : 10, height: 16 } },
		river10:		{ land: true, imgdata: { num: 0, ix: 25, iy :  0, height: 16 } },
		river5:			{ land: true, imgdata: { num: 0, ix: 24, iy :  0, height: 16 } },
		river19:		{ land: true, imgdata: { num: 0, ix:  2, iy :  4, height: 16 } },
		river38:		{ land: true, imgdata: { num: 0, ix:  0, iy :  3, height: 16 } },
		river76:		{ land: true, imgdata: { num: 0, ix:  1, iy :  3, height: 16 } },
		river137:		{ land: true, imgdata: { num: 0, ix:  3, iy :  4, height: 16 } },
		river55:		{ land: true, imgdata: { num: 0, ix: 19, iy :  7, height: 16 } },
		river110:		{ land: true, imgdata: { num: 0, ix: 22, iy :  9, height: 16 } },
		river205:		{ land: true, imgdata: { num: 0, ix: 20, iy :  7, height: 16 } },
		river155:		{ land: true, imgdata: { num: 0, ix: 24, iy : 10, height: 16 } },
		river255:		{ land: true, imgdata: { num: 0, ix: 27, iy :  0, height: 16 } },
		river3:			{ land: true, imgdata: { num: 0, ix:  6, iy :  6, height: 16 } },
		river6:			{ land: true, imgdata: { num: 0, ix:  4, iy :  5, height: 16 } },
		river12:		{ land: true, imgdata: { num: 0, ix:  5, iy :  5, height: 16 } },
		river9:			{ land: true, imgdata: { num: 0, ix:  7, iy :  6, height: 16 } },
		river7:			{ land: true, imgdata: { num: 0, ix:  4, iy :  3, height: 16 } },
		river23:		{ land: true, imgdata: { num: 0, ix:  8, iy :  5, height: 16 } },
		river39:		{ land: true, imgdata: { num: 0, ix:  6, iy :  4, height: 16 } },
		river14:		{ land: true, imgdata: { num: 0, ix:  0, iy :  2, height: 16 } },
		river46:		{ land: true, imgdata: { num: 0, ix: 20, iy :  6, height: 16 } },
		river78:		{ land: true, imgdata: { num: 0, ix: 21, iy :  6, height: 16 } },
		river13:		{ land: true, imgdata: { num: 0, ix:  5, iy :  3, height: 16 } },
		river77:		{ land: true, imgdata: { num: 0, ix:  7, iy :  4, height: 16 } },
		river141:		{ land: true, imgdata: { num: 0, ix:  9, iy :  5, height: 16 } },
		river11:		{ land: true, imgdata: { num: 0, ix:  1, iy :  2, height: 16 } },
		river139:		{ land: true, imgdata: { num: 0, ix: 24, iy :  7, height: 16 } },
		river27:		{ land: true, imgdata: { num: 0, ix: 23, iy :  7, height: 16 } },
		river15:		{ land: true, imgdata: { num: 0, ix:  1, iy :  1, height: 16 } },
		sea_r1:			{ imgdata: { num: 0, ix: 25, iy :  9, height: 16 } },
		sea_r2:			{ imgdata: { num: 0, ix: 26, iy :  9, height: 16 } },
		sea_r4:			{ imgdata: { num: 0, ix: 23, iy :  8, height: 16 } },
		sea_r8:			{ imgdata: { num: 0, ix: 24, iy :  8, height: 16 } },
		sea0:				{ imgdata: { num: 0, ix: 12, iy :  1, height: 16 } },
		sea1:				{ imgdata: { num: 0, ix: 14, iy :  2, height: 16 } },
		sea2:				{ imgdata: { num: 0, ix: 10, iy :  1, height: 16 } },
		sea4:				{ imgdata: { num: 0, ix: 10, iy :  0, height: 16 } },
		sea8:				{ imgdata: { num: 0, ix: 14, iy :  1, height: 16 } },
		sea5:				{ imgdata: { num: 0, ix: 18, iy :  3, height: 16 } },
		sea10:			{ imgdata: { num: 0, ix: 12, iy :  0, height: 16 } },
		sea3:				{ imgdata: { num: 0, ix: 13, iy :  2, height: 16 } },
		sea6:				{ imgdata: { num: 0, ix: 11, iy :  1, height: 16 } },
		sea12:			{ imgdata: { num: 0, ix: 13, iy :  1, height: 16 } },
		sea9:				{ imgdata: { num: 0, ix: 15, iy :  2, height: 16 } },
		sea7:				{ imgdata: { num: 0, ix: 19, iy :  4, height: 16 } },
		sea14:			{ imgdata: { num: 0, ix: 17, iy :  4, height: 16 } },
		sea13:			{ imgdata: { num: 0, ix: 16, iy :  3, height: 16 } },
		sea11:			{ imgdata: { num: 0, ix: 14, iy :  3, height: 16 } },
		sea15:			{ imgdata: { num: 0, ix:  8, iy :  0, height: 16 } },
		sea16:			{ imgdata: { num: 0, ix: 12, iy :  2, height: 16 } },
		sea32:			{ imgdata: { num: 0, ix:  9, iy :  0, height: 16 } },
		sea64:			{ imgdata: { num: 0, ix: 11, iy :  0, height: 16 } },
		sea128:			{ imgdata: { num: 0, ix: 16, iy :  2, height: 16 } },
		sea48:			{ imgdata: { num: 0, ix: 18, iy :  4, height: 16 } },
		sea80:			{ imgdata: { num: 0, ix: 13, iy :  0, height: 16 } },
		sea144:			{ imgdata: { num: 0, ix: 16, iy :  4, height: 16 } },
		sea96:			{ imgdata: { num: 0, ix: 15, iy :  3, height: 16 } },
		sea160:			{ imgdata: { num: 0, ix: 15, iy :  1, height: 16 } },
		sea192:			{ imgdata: { num: 0, ix: 17, iy :  3, height: 16 } },
		sea112:			{ imgdata: { num: 0, ix:  7, iy : 10, height: 16 } },
		sea176:			{ imgdata: { num: 0, ix:  9, iy : 10, height: 16 } },
		sea208:			{ imgdata: { num: 0, ix: 10, iy : 10, height: 16 } },
		sea224:			{ imgdata: { num: 0, ix:  8, iy : 10, height: 16 } },
		sea240:			{ imgdata: { num: 0, ix: 11, iy : 10, height: 16 } },
		sea33:			{ imgdata: { num: 0, ix:  3, iy :  8, height: 16 } },
		sea65:			{ imgdata: { num: 0, ix:  4, iy :  8, height: 16 } },
		sea97:			{ imgdata: { num: 0, ix:  5, iy :  8, height: 16 } },
		sea66:			{ imgdata: { num: 0, ix: 19, iy :  5, height: 16 } },
		sea130:			{ imgdata: { num: 0, ix:  1, iy :  7, height: 16 } },
		sea194:			{ imgdata: { num: 0, ix: 21, iy :  5, height: 16 } },
		sea132:			{ imgdata: { num: 0, ix:  6, iy :  9, height: 16 } },
		sea20:			{ imgdata: { num: 0, ix:  5, iy :  9, height: 16 } },
		sea148:			{ imgdata: { num: 0, ix:  7, iy :  9, height: 16 } },
		sea24:			{ imgdata: { num: 0, ix:  0, iy :  7, height: 16 } },
		sea40:			{ imgdata: { num: 0, ix: 18, iy :  5, height: 16 } },
		sea56:			{ imgdata: { num: 0, ix: 20, iy :  5, height: 16 } },
		sea67:			{ imgdata: { num: 0, ix:  7, iy :  8, height: 16 } },
		sea134:			{ imgdata: { num: 0, ix:  9, iy :  9, height: 16 } },
		sea28:			{ imgdata: { num: 0, ix:  8, iy :  9, height: 16 } },
		sea41:			{ imgdata: { num: 0, ix:  6, iy :  8, height: 16 } },
		sea_r1:			{ imgdata: { num: 0, ix: 25, iy :  9, height: 16 } },
		sea_r2:			{ imgdata: { num: 0, ix: 26, iy :  9, height: 16 } },
		sea_r4:			{ imgdata: { num: 0, ix: 23, iy :  8, height: 16 } },
		sea_r8:			{ imgdata: { num: 0, ix: 24, iy :  8, height: 16 } },
		shoal1:			{ imgdata: { num: 0, ix: 10, iy :  8, height: 16 } },
		shoal17:		{ imgdata: { num: 0, ix:  5, iy :  7, height: 16 } },
		shoal129:		{ imgdata: { num: 0, ix:  6, iy :  7, height: 16 } },
		shoal145:		{ imgdata: { num: 0, ix: 20, iy :  2, height: 16 } },
		shoal2:			{ imgdata: { num: 0, ix: 26, iy :  4, height: 16 } },
		shoal34:		{ imgdata: { num: 0, ix: 25, iy :  5, height: 16 } },
		shoal18:		{ imgdata: { num: 0, ix:  7, iy :  7, height: 16 } },
		shoal50:		{ imgdata: { num: 0, ix: 16, iy :  1, height: 16 } },
		shoal4:			{ imgdata: { num: 0, ix: 23, iy :  4, height: 16 } },
		shoal68:		{ imgdata: { num: 0, ix: 20, iy :  3, height: 16 } },
		shoal36:		{ imgdata: { num: 0, ix: 19, iy :  3, height: 16 } },
		shoal100:		{ imgdata: { num: 0, ix: 16, iy :  0, height: 16 } },
		shoal8:			{ imgdata: { num: 0, ix: 27, iy :  4, height: 16 } },
		shoal136:		{ imgdata: { num: 0, ix:  8, iy :  7, height: 16 } },
		shoal72:		{ imgdata: { num: 0, ix: 26, iy :  5, height: 16 } },
		shoal200:		{ imgdata: { num: 0, ix: 20, iy :  1, height: 16 } },
		shoal3:			{ imgdata: { num: 0, ix: 16, iy :  9, height: 16 } },
		shoal35:		{ imgdata: { num: 0, ix: 28, iy :  5, height: 16 } },
		shoal131:		{ imgdata: { num: 0, ix: 16, iy :  9, height: 16 } },
		shoal163:		{ imgdata: { num: 0, ix: 18, iy :  2, height: 16 } },
		shoal6:			{ imgdata: { num: 0, ix: 12, iy :  6, height: 16 } },
		shoal70:		{ imgdata: { num: 0, ix: 14, iy :  8, height: 16 } },
		shoal22:		{ imgdata: { num: 0, ix: 10, iy :  7, height: 16 } },
		shoal86:		{ imgdata: { num: 0, ix: 17, iy :  1, height: 16 } },
		shoal12:		{ imgdata: { num: 0, ix: 13, iy :  6, height: 16 } },
		shoal140:		{ imgdata: { num: 0, ix: 11, iy :  7, height: 16 } },
		shoal44:		{ imgdata: { num: 0, ix: 13, iy :  8, height: 16 } },
		shoal172:		{ imgdata: { num: 0, ix: 19, iy :  1, height: 16 } },
		shoal9:			{ imgdata: { num: 0, ix: 16, iy :  7, height: 16 } },
		shoal25:		{ imgdata: { num: 0, ix: 15, iy :  9, height: 16 } },
		shoal73:		{ imgdata: { num: 0, ix: 29, iy :  5, height: 16 } },
		shoal89:		{ imgdata: { num: 0, ix: 21, iy :  2, height: 16 } },
		shoal7:			{ imgdata: { num: 0, ix: 24, iy :  2, height: 16 } },
		shoal14:		{ imgdata: { num: 0, ix: 25, iy :  2, height: 16 } },
		shoal13:		{ imgdata: { num: 0, ix: 23, iy :  2, height: 16 } },
		shoal11:		{ imgdata: { num: 0, ix: 27, iy :  3, height: 16 } },
		mcannon_u:	{ land: true, candestroy: true, hp: 99, shadow: true, imgdata: { num: 3, ix: 3, iy :  0, height: 32 } },
		mcannon_r:	{ land: true, candestroy: true, hp: 99, shadow: true, imgdata: { num: 3, ix: 5, iy :  0, height: 32 } },
		mcannon_d:	{ land: true, candestroy: true, hp: 99, shadow: true, imgdata: { num: 3, ix: 2, iy :  0, height: 32 } },
		mcannon_l:	{ land: true, candestroy: true, hp: 99, shadow: true, imgdata: { num: 3, ix: 4, iy :  0, height: 32 } },
		mcannon_all:	{ land: true, candestroy: true, hp: 99, shadow: true, imgdata: { num: 3, ix: 1, iy :  0, height: 32 } },
		bstone:				{ land: true, candestroy: true, hp: 99, shadow: true, newline: true, imgdata: { num: 3, ix: 7, iy :  0, height: 32 } },
		mcannon_airl:	{ candestroy: true, hp: 99, shadow: true, imgdata: { num: 3, ix: 8, iy :  0, height: 32 } },
	};

	let Buildinglist = {
		hq:				{	land: true, hq: true, shadow: true, imgdata: { num: 2, ix: 0, iy : 0, height: 32 } },
		city:			{	land: true, shadow: true, imgdata: { num: 2, ix: 6, iy : 0, height: 32 } },
		base:			{	land: true, shadow: true , imgdata: { num: 2, ix: 6, iy : 2, height: 32 }},
		airport:	{	land: true, shadow: true, imgdata: { num: 2, ix: 6, iy : 4, height: 32 } },
		seaport:	{	land: true, shadow: true, imgdata: { num: 2, ix: 6, iy : 6, height: 32 } },
		comtower: {	land: true, shadow: true, imgdata: { num: 2, ix: 6, iy : 8, height: 32 } },
		rlab:			{	land: true, hq: true, shadow: true, imgdata: { num: 2, ix: 0, iy : 10, height: 32 } },
	}

	let LargeBuildinglist = {
		bcannon_u:	{ land: true, large: true, size: 3, destroyx: 1, destroyy: 2, imgdata: { num: 4, ix: 3, iy : 0, height: 48 } },
		bcannon_d:	{ land: true, large: true, size: 3, destroyx: 1, destroyy: 2, imgdata: { num: 4, ix: 0, iy : 0, height: 48 } },
		bcrystal:		{ land: true, large: true, size: 3, destroyx: 1, destroyy: 2, imgdata: { num: 4, ix: 6, iy : 0, height: 48 } },
		bruin:			{ land: true, large: true, size: 3, imgdata: { num: 4, ix: 9, iy : 0, height: 48 } },
		misslelauncher:	{ land: true, large: true, size: 4, imgdata: { num: 4, ix: 0, iy : 3, height: 64 } },
		largebuilding:	{ land: true, large: true, size: 4, imgdata: { num: 4, ix: 4, iy : 3, height: 64 } },
		volcano:		{ land: true, large: true, size: 4, imgdata: { num: 4, ix: 8, iy : 3, height: 64 } },
		blackarc:		{ large: true, size: 4, imgdata: { num: 4, ix: 4, iy : 7, height: 64 } },
	};

	let Unit = {
		infantry:		{},
		mech:				{},
		apc:				{},
		oozium: 		{},
		recon:			{},
		tank:				{},
		mdtank:			{},
		neotank:		{},
		megatank:		{},
		antiair:		{},
		artillery:	{},
		rocket:			{},
		missle:			{},
		piperunner:	{},
		tcopter:		{},
		bcopter:		{},
		fighter:		{},
		bomber:			{},
		stealth:		{},
		blackbomb:	{},
		blackboat:	{},
		lander:			{},
		cruiser:		{},
		battleship:	{},
		carrier:		{},
		sub:				{},
	};

	let Unit_imglist = {
		infantry:		{ imgdata: { num: 0, ix:  0, iy : 0, height: 16 } },
		mech:				{ imgdata: { num: 0, ix:  5, iy : 0, height: 16 } },
		apc:				{ imgdata: { num: 1, ix:  5, iy : 0, height: 16 } },
		oozium: 		{ imgdata: { num: 1, ix: 11, iy : 0, height: 16 } },
		recon:			{ imgdata: { num: 1, ix:  0, iy : 0, height: 16 } },
		tank:				{ imgdata: { num: 1, ix:  1, iy : 0, height: 16 } },
		mdtank:			{ imgdata: { num: 1, ix:  2, iy : 0, height: 16 } },
		neotank:		{ imgdata: { num: 1, ix:  3, iy : 0, height: 16 } },
		megatank:		{ imgdata: { num: 1, ix:  4, iy : 0, height: 16 } },
		antiair:		{ imgdata: { num: 1, ix:  8, iy : 0, height: 16 } },
		artillery:	{ imgdata: { num: 1, ix:  6, iy : 0, height: 16 } },
		rocket:			{ imgdata: { num: 1, ix:  7, iy : 0, height: 16 } },
		missle:			{ imgdata: { num: 1, ix:  9, iy : 0, height: 16 } },
		piperunner:	{ imgdata: { num: 1, ix: 10, iy : 0, height: 16 } },
		tcopter:		{ imgdata: { num: 2, ix:  3, iy : 0, height: 16 } },
		bcopter:		{ imgdata: { num: 2, ix:  2, iy : 0, height: 16 } },
		fighter:		{ imgdata: { num: 2, ix:  0, iy : 0, height: 16 } },
		bomber:			{ imgdata: { num: 2, ix:  1, iy : 0, height: 16 } },
		stealth:		{ imgdata: { num: 2, ix:  4, iy : 0, height: 16 } },
		blackbomb:	{ imgdata: { num: 2, ix:  5, iy : 0, height: 16 } },
		blackboat:	{ imgdata: { num: 3, ix:  4, iy : 0, height: 16 } },
		lander:			{ imgdata: { num: 3, ix:  2, iy : 0, height: 16 } },
		cruiser:		{ imgdata: { num: 3, ix:  1, iy : 0, height: 16 } },
		battleship:	{ imgdata: { num: 3, ix:  0, iy : 0, height: 16 } },
		carrier:		{ imgdata: { num: 3, ix:  5, iy : 0, height: 16 } },
		sub:				{ imgdata: { num: 3, ix:  3, iy : 0, height: 16 } },
	}

	let TerrainUI_data = [
		{	type: "imgsp",	name:	"plain" },
		{	type: "imgsp",	name:	"plain_pd" },
		{	type: "imgsp",	name:	"wood" },
		{	type: "imgsp",	name:	"mountain" },
		{	type: "imgsp",	name:	"road" },
		{	type: "imgsp",	name:	"bridge" },
		{	type: "imgsp",	name:	"pipe" },
		{	type: "imgsp",	name:	"pipe_c" },
		{ type: "newline" },
		{	type: "imgsp",	name:	"river" },
		{	type: "imgsp",	name:	"sea" },
		{	type: "imgsp",	name:	"reef" },
		{	type: "imgsp",	name:	"shoal" },
		{	type: "imgsp",	name:	"missle" },
		{	type: "imgsp",	name:	"misslenone" },
		{ type: "space", x: Terrain_UI_width },
		{	type: "imgsp",	name:	"wideriver" },
		{ type: "newline", y: 10 },
	];

	let Terrain_Land_UI_data = [
		{	type: "imgsp",	name:	"road10" },
		{	type: "imgsp",	name:	"road5" },
		{	type: "imgsp",	name:	"road3" },
		{	type: "imgsp",	name:	"road6" },
		{	type: "imgsp",	name:	"road12" },
		{	type: "imgsp",	name:	"road9" },
		{	type: "imgsp",	name:	"road7" },
		{	type: "imgsp",	name:	"road14" },
		{ type: "newline" },
		{	type: "imgsp",	name:	"road13" },
		{	type: "imgsp",	name:	"road11" },
		{	type: "imgsp",	name:	"road15" },
		{ type: "space", x: Terrain_UI_width },
		{	type: "imgsp",	name:	"mountain2" },
		{	type: "imgsp",	name:	"mountain3" },
		{	type: "imgsp",	name:	"bridgeh" },
		{	type: "imgsp",	name:	"bridgev" },
		{ type: "newline" },
		{	type: "imgsp",	name:	"pipe10" },
		{	type: "imgsp",	name:	"pipe5" },
		{	type: "imgsp",	name:	"pipe3" },
		{	type: "imgsp",	name:	"pipe6" },
		{	type: "imgsp",	name:	"pipe12" },
		{	type: "imgsp",	name:	"pipe9" },
		{	type: "imgsp",	name:	"pipe4" },
		{	type: "imgsp",	name:	"pipe8" },
		{ type: "newline" },
		{	type: "imgsp",	name:	"pipe1" },
		{	type: "imgsp",	name:	"pipe2" },
		{ type: "space", x: Terrain_UI_width },
		{	type: "imgsp",	name:	"pipe_cv" },
		{	type: "imgsp",	name:	"pipe_ch" },
		{	type: "imgsp",	name:	"plain_pdh" },
		{	type: "imgsp",	name:	"plain_pdv" },
		{ type: "newline" },
		{	type: "imgsp",	name:	"mcannon_u" },
		{	type: "imgsp",	name:	"mcannon_r" },
		{	type: "imgsp",	name:	"mcannon_d" },
		{	type: "imgsp",	name:	"mcannon_l" },
		{	type: "imgsp",	name:	"mcannon_all" },
		{	type: "imgsp",	name:	"bstone" },
		{	type: "imgsp",	name:	"mcannon_airl" },
		{ type: "newline" },
	];

	let Terrain_Sea_UI_data = [
		{	type: "imgsp",	name:	"sea9" },
		{	type: "imgsp",	name:	"sea1" },
		{	type: "imgsp",	name:	"sea3" },
		{ type: "space", x: Terrain_UI_width },
		{	type: "imgsp",	name:	"sea33" },
		{	type: "imgsp",	name:	"sea97" },
		{	type: "imgsp",	name:	"sea65" },
		{ type: "newline" },

		{	type: "imgsp",	name:	"sea8" },
		{	type: "imgsp",	name:	"sea0" },
		{	type: "imgsp",	name:	"sea2" },
		{	type: "imgsp",	name:	"sea40" },
		{ type: "space", x: Terrain_UI_width },
		{	type: "imgsp",	name:	"sea14" },
		{ type: "space", x: Terrain_UI_width },
		{	type: "imgsp",	name:	"sea66" },
		{ type: "newline" },

		{	type: "imgsp",	name:	"sea12" },
		{	type: "imgsp",	name:	"sea4" },
		{	type: "imgsp",	name:	"sea6" },
		{	type: "imgsp",	name:	"sea56" },
		{	type: "imgsp",	name:	"sea7" },
		{	type: "imgsp",	name:	"sea15" },
		{	type: "imgsp",	name:	"sea13" },
		{	type: "imgsp",	name:	"sea194" },
		{ type: "newline" },

		{	type: "imgsp",	name:	"sea32" },
		{	type: "imgsp",	name:	"sea96" },
		{	type: "imgsp",	name:	"sea64" },

		{	type: "imgsp",	name:	"sea24" },
		{ type: "space", x: Terrain_UI_width },
		{	type: "imgsp",	name:	"sea11" },
		{ type: "space", x: Terrain_UI_width },
		{	type: "imgsp",	name:	"sea130" },
		{ type: "newline" },

		{	type: "imgsp",	name:	"sea48" },
		{	type: "imgsp",	name:	"sea240" },
		{	type: "imgsp",	name:	"sea192" },
		{ type: "space", x: Terrain_UI_width },
		{	type: "imgsp",	name:	"sea20" },
		{	type: "imgsp",	name:	"sea148" },
		{	type: "imgsp",	name:	"sea132" },
		{ type: "newline" },


		{	type: "imgsp",	name:	"sea16" },
		{	type: "imgsp",	name:	"sea144" },
		{	type: "imgsp",	name:	"sea128" },

		{	type: "imgsp",	name:	"sea112" },
		{	type: "imgsp",	name:	"sea224" },

		{	type: "imgsp",	name:	"sea41" },
		{	type: "imgsp",	name:	"sea5" },
		{	type: "imgsp",	name:	"sea67" },
		{ type: "newline" },

		{	type: "imgsp",	name:	"sea_r1" },
		{	type: "imgsp",	name:	"sea_r2" },
		{ type: "space", x: Terrain_UI_width },
		{	type: "imgsp",	name:	"sea176" },
		{	type: "imgsp",	name:	"sea208" },

		{	type: "imgsp",	name:	"sea10" },
		{ type: "space", x: Terrain_UI_width  },
		{	type: "imgsp",	name:	"sea10" },
		{ type: "newline" },

		{	type: "imgsp",	name:	"sea_r4" },
		{	type: "imgsp",	name:	"sea_r8" },
		{ type: "space", x: Terrain_UI_width * 0.5 },
		{	type: "imgsp",	name:	"sea80" },
		{	type: "imgsp",	name:	"sea160" },
		{ type: "space", x: Terrain_UI_width * 0.5 },
		{	type: "imgsp",	name:	"sea28" },
		{	type: "imgsp",	name:	"sea5" },
		{	type: "imgsp",	name:	"sea134" },
		{ type: "newline" },
	];

	let Terrain_Shoal_UI_data = [
		{	type: "imgsp",	name:	"shoal89" },
		{	type: "imgsp",	name:	"shoal145" },
		{	type: "imgsp",	name:	"shoal163" },

		{	type: "imgsp",	name:	"shoal25" },
		{	type: "imgsp",	name:	"shoal129" },
		{	type: "imgsp",	name:	"shoal17" },
		{	type: "imgsp",	name:	"shoal131" },
		{ type: "newline" },

		{	type: "imgsp",	name:	"shoal200" },
		{ type: "space", x: Terrain_UI_width },
		{	type: "imgsp",	name:	"shoal50" },

		{	type: "imgsp",	name:	"shoal8" },
		{ type: "space", x: Terrain_UI_width * 2 },
		{	type: "imgsp",	name:	"shoal2" },
		{ type: "newline" },

		{	type: "imgsp",	name:	"shoal172" },
		{	type: "imgsp",	name:	"shoal100" },
		{	type: "imgsp",	name:	"shoal86" },

		{	type: "imgsp",	name:	"shoal44" },
		{	type: "imgsp",	name:	"shoal68" },
		{	type: "imgsp",	name:	"shoal36" },
		{	type: "imgsp",	name:	"shoal70" },
		{ type: "newline" },

		{	type: "imgsp",	name:	"shoal73" },
		{	type: "imgsp",	name:	"shoal1" },
		{	type: "imgsp",	name:	"shoal35" },
		{ type: "space", x: Terrain_UI_width * 2 },
		{	type: "imgsp",	name:	"shoal11" },
		{ type: "newline" },


		{	type: "imgsp",	name:	"shoal136" },
		{ type: "space", x: Terrain_UI_width },
		{	type: "imgsp",	name:	"shoal18" },
		{ type: "space", x: Terrain_UI_width },
		{	type: "imgsp",	name:	"shoal9" },
		{ type: "space", x: Terrain_UI_width },
		{	type: "imgsp",	name:	"shoal3" },
		{ type: "newline" },

		{	type: "imgsp",	name:	"shoal72" },
		{ type: "space", x: Terrain_UI_width },
		{	type: "imgsp",	name:	"shoal34" },

		{	type: "imgsp",	name:	"shoal13" },
		{ type: "space", x: Terrain_UI_width * 3 },
		{	type: "imgsp",	name:	"shoal7" },
		{ type: "newline" },

		{	type: "imgsp",	name:	"shoal140" },
		{	type: "imgsp",	name:	"shoal4" },
		{	type: "imgsp",	name:	"shoal22" },
		{ type: "space", x: Terrain_UI_width },
		{	type: "imgsp",	name:	"shoal12" },
		{ type: "space", x: Terrain_UI_width },
		{	type: "imgsp",	name:	"shoal6" },
		{ type: "newline" },

		{ type: "space", x: Terrain_UI_width * 5},
		{	type: "imgsp",	name:	"shoal14" },
		{ type: "newline" },
	];

	let Terrain_River_UI_data = [
		{	type: "imgsp",	name:	"shoal89" },
		{	type: "imgsp",	name:	"shoal145" },
		{	type: "imgsp",	name:	"shoal163" },
	];

	let UnitUI_data = {
		no: [
			{ type: "imgsp2",		name: "infantry" },
			{ type: "imgsp2",		name: "mech" },
			{ type: "imgsp2",		name: "apc" },
			{ type: "imgsp2",		name: "oozium" },
			{ type: "space",	x: Terrain_UI_width },
			{ type: "img",		name: "delete",	fiximage: true, src: "image/button/delete.png" },
			{ type: "newline" },
			{ type: "imgsp2",		name: "recon" },
			{ type: "imgsp2",		name: "tank" },
			{ type: "imgsp2",		name: "mdtank" },
			{ type: "imgsp2",		name: "neotank" },
			{ type: "imgsp2",		name: "megatank" },
			{ type: "imgsp2",		name: "antiair" },
			{ type: "newline" },
			{ type: "imgsp2",		name: "artillery" },
			{ type: "imgsp2",		name: "rocket" },
			{ type: "imgsp2",		name: "missle" },
			{ type: "imgsp2",		name: "piperunner" },
			{ type: "newline" },
			{ type: "imgsp2",		name: "tcopter" },
			{ type: "imgsp2",		name: "bcopter" },
			{ type: "imgsp2",		name: "fighter" },
			{ type: "imgsp2",		name: "bomber" },
			{ type: "imgsp2",		name: "stealth" },
			{ type: "imgsp2",		name: "blackbomb" },
			{ type: "newline" },
			{ type: "imgsp2",		name: "blackboat" },
			{ type: "imgsp2",		name: "lander" },
			{ type: "imgsp2",		name: "cruiser" },
			{ type: "imgsp2",		name: "battleship" },
			{ type: "imgsp2",		name: "carrier" },
			{ type: "imgsp2",		name: "sub" },
		]
	};

	for (let i = 0 ; i < Country.length ; i++) {
		TerrainUI_data.push({ type: "space", x: Terrain_UI_width });
		let c = Country[i];
		for (let bname in Buildinglist) {
			let b = Buildinglist[bname];
			if (b.hq && c.npc) {
				TerrainUI_data.push({ type: "space", x: Terrain_UI_width });
				continue;
			}
			let cname = c.fname;
			let t = Terrain_imglist[bname + "_" + cname] = copyobject(b);
			t.country = c.fname;
			if (bname == "hq") {
				t.imgdata.ix = i;
				t.imgdata.iy = (i - 1) * 2;
				TerrainUI_data.push({ type: "imgsp", name: bname + "_" + cname });
			}
			else {
				t.imgdata.ix += i;
				TerrainUI_data.push({ type: "imgsp", name: bname + "_" + cname });
			}
		}
		TerrainUI_data.push({ type: "newline" });

		if (!c.npc) {
			let udata = UnitUI_data[c.fname] = [];
			for (let j = 0 ; j < UnitUI_data["no"].length ; j++) {
				let u = copyobject(UnitUI_data["no"][j]);
				if (u.name !== undefined && u.name !== "delete") {
					let name = u.name + "_" + c.fname;
					Unit_imglist[name] = copyobject(Unit_imglist[u.name]);
					Unit_imglist[name].imgdata.iy += i - 1;
					Unit_imglist[name].country = c.fname;
					u.name += "_" + c.fname;
				}
				udata.push(u);
			}
		}
	}

	for (let bname in LargeBuildinglist) {
		let b = LargeBuildinglist[bname];
		Terrain_imglist[bname] = copyobject(b);
		for (let x = 0 ; x < b.size ; x++) {
			for (let y = 0 ; y < b.size ; y++) {
				let t = Terrain_imglist[bname + x + "" + y] = copyobject(b);
				t.imgdata.ix += x;
				t.imgdata.iy += y;
				t.imgdata.x = x;
				t.imgdata.y = y;
				t.imgdata.height = 16;
			}
		}
		Terrain_Land_UI_data.push({ type: "imgsp", name: bname });
	}

	let Maptype = [
		{ fname: "normal" },
		{ fname: "wasteland" },
		{ fname: "desert" },
		{ fname: "snow" },
	];

	let terrainimg = [];
	for (let i = 0 ; i < 5 ; i++) {
		terrainimg[i] = [];
		for (let k = 0 ; k < Maptype.length ; k++) {
			terrainimg[i][k] = new Image();
 			terrainimg[i][k].src = "image/terrain/" + Maptype[k].fname + "/images" + i + ".png";
		}
	}

	let unitimg = [];
	for (let i = 0 ; i < 4 ; i++) {
		unitimg[i] = new Image();
		unitimg[i].src = "image/unit/images" + i + ".png";
	}

	let changesizeimg = new Image();
	changesizeimg.src = "image/button/changesize.png";

	function getmyid() {
		idcount++;
		return idcount;
	}

	function copyobject(obj) {
		if (typeof obj != "object") {
			return obj;
		}
		let type = Object.prototype.toString.call(obj);
		if (type == "[object Object]") {
			let retval = {};
			for (let p in obj) {
				retval[p] = copyobject(obj[p]);
			}
			return retval;
		}
		else if (type == "[object Array]") {
			let retval = [];
			for (let i = 0 ; i < obj.length ; i++) {
				retval[i] = copyobject(obj[i]);
			}
			return retval;
		}
		else {
			return obj;
		}
	}

	function FWEditor(canvasid) {
		let id = getmyid();

		this.resizedrag = false;

		this.savedata = {
			fwmapdataver:	2,
			mapdata: {},
			countrydata: {},
		};

		this.canvas = document.getElementById(canvasid);
		this.canvas.me = this;
		if (!this.canvas || !this.canvas.getContext) {
			this.canuse = false;
			return;
 		}
		this.canuse = true;
		this.ctx = this.canvas.getContext('2d');

		this.canvas.onmousemove = function(evt) {
			let me = this.me;
			let rect = this.getBoundingClientRect();
			let mx, my;
			me.mx = mx = Math.floor(evt.clientX - rect.left);
			me.my = my = Math.floor(evt.clientY - rect.top);
			let dragx = me.dragx;
			let dragy = me.dragy;
			if (me.usetool) {
				let cx = Math.floor(mx / Sqsize);
				let cy = Math.floor(my / Sqsize);
				if (me.select_mode === "Terrain" || me.select_mode === "Extra" || me.select_mode === "Extra2") {
					if (evt.buttons & 1) {
						me.setmap(cx, cy, me.select_terrain);
					}
					else if (evt.buttons & 2) {
						let fromx = (cx < dragx) ? cx : dragx;
						let fromy = (cy < dragy) ? cy : dragy;
						let tox = (cx > dragx) ? cx : dragx;
						let toy = (cy > dragy) ? cy : dragy;
						let tname = me.select_terrain;
						let t = Terrain_imglist[tname];
						let plus = (t.large) ? t.size : 1;
						me.restoremap();
						for (let x = dragx ; (dragx < cx) ? x <= cx : x >= cx ; x += plus * ((dragx < cx) ? 1 : -1)) {
							for (let y = dragy ; (dragy < cy) ? y <= cy : y >= cy ; y += plus * ((dragy < cy) ? 1 : -1)) {
								me.setmap(x, y, tname);
							}
						}
					}
				}
				else if (me.select_mode === "Unit") {
					if (evt.buttons & 1) {
						let c = me.select_unitcountry;
						let u = me.select_unit;
						let selunit = me.findunit(cx, cy);
						if (selunit !== false && (u === "delete" || me.select_unitlock !== "lock")) {
							me.deleteunit(selunit.country, selunit.index);
						}
						if (u !== "delete" && me.findunit(cx, cy) === false) {
							me.setunit(cx, cy, c, u);
						}
						me.setunitmap();
					}
					else if (evt.buttons & 2) {
						let selunit = me.findunit(cx, cy);
						if (selunit !== false) {
							me.deleteunit(selunit.country, selunit.index);
						}
						me.setunitmap();
					}
				}
				else if (me.select_mode == "Map") {
					if (me.resizedrag) {
						let w = Math.floor(mx / Sqsize) + 1;
						let h = Math.floor(my / Sqsize) + 1;
						if (!(w <= 0 || w > Maxwidth || h <= 0 || h > Maxheight)) {
							if (me.savedata.mapdata.width != w || me.savedata.mapdata.height != h) {
								me.init(w, h, false);
							}
						}
					}
				}
			}
			me.draw();
		}
		this.canvas.onmousedown = function(evt) {
			let rect = this.getBoundingClientRect();
			let me = this.me;
			let map = me.savedata.mapdata.map;
			let tx = me.tx;
			let ty = me.ty;
			let mx, my;

			me.mx = mx = Math.floor(evt.clientX - rect.left);
			me.my = my = Math.floor(evt.clientY - rect.top);

			if (me.select_mode === "Terrain" || me.select_mode === "Extra") {
				if (evt.buttons & 2) {
					me.backupmap();
					me.dragx = Math.floor(mx / Sqsize);
					me.dragy = Math.floor(my / Sqsize);
				}
			}
			else if (me.select_mode == "Map") {
				let r = UI_Rect((me.savedata.mapdata.width - 0.5) * Sqsize, (me.savedata.mapdata.height - 0.5) * Sqsize, Sqsize, Sqsize);
				if (r.isinside(mx, my)) {
					me.resizedrag = true;
				}
			}
			this.onmousemove(evt);
			me.draw();
		}
		this.canvas.onmouseup = function(evt) {
			let me = this.me;
			let rect = this.getBoundingClientRect();
			me.mx = Math.floor(evt.clientX - rect.left);
			me.my = Math.floor(evt.clientY - rect.top);
			this.me.resizedrag = false;
			me.draw();
		}

		this.canvas.onmouseout = function(evt) {
			let me = this.me;
			me.resizedrag = false;
			me.draw();
		}
		this.canvas.oncontextmenu = function(evt) {
			return false;
		}
	
		this.usetool = true;

		this.getversion = function() {
			return version;
		}
		this.getlastupdate = function() {
			return lastupdate;
		}
		this.getsize = function() {
			return { width: this.savedata.mapdata.width, height: this.savedata.mapdata.height }
		};
		this.setsize = function(w, h, clear) {
			if (w <= 0 || w > Maxwidth) {
				w = Defaultwidth;
			}
			if (h <= 0 || h > Maxheight) {
				h = Defaultheight;
			}
			let newmap = [];
			this.mapbeforedrag = [];
			for (let x = 0 ; x < w ; x++) {
				newmap[x] = [];
				this.mapbeforedrag[x] = [];
				for (let y = 0 ; y < h ; y++) {
					if (!clear && x < this.savedata.mapdata.width && y < this.savedata.mapdata.height) {
						newmap[x][y] = this.savedata.mapdata.map[x][y];
					}
					else {
						newmap[x][y] = "plain";
					}
					this.mapbeforedrag[x][y] = 0;
				}
			}
			this.savedata.mapdata.map = newmap;

			if (clear) {
				for (let i = 0 ; i < Country.length ; i++) {
					let c = Country[i];
					if (c.npc) {
						continue;
					}
					let cdata = this.savedata.countrydata[c.fname];
					cdata.front.shogun = null;
					cdata.front.bp = 0;
					cdata.back.shogun = null;
					cdata.back.bp = 0;
					cdata.money = 0;
					cdata.unitdirection = "normal";
					cdata.unitcountrytype = c.fname;
					cdata.unitdata = [];
				}
			}
			else {
				for (let i = 0 ; i < Country.length ; i++) {
					let c = Country[i];
					if (c.npc) {
						continue;
					}
					let u = this.savedata.countrydata[c.fname].unitdata;
					for (let j = 0 ; j < u.length ; j++) {
						if (!(u[j].x < w && u[j].y < h)) {
							u.splice(j, 1);
							j--;
						}
					}
				}
			}
			this.savedata.mapdata.width = w;
			this.savedata.mapdata.height = h;
			this.setunitmap();
		}

		this.findunit = function(x, y) {
			for (let i = 0 ; i < Country.length ; i++) {
				let c = Country[i];
				if (c.npc) {
					continue;
				}
				let udata = this.savedata.countrydata[c.fname].unitdata;
				for (let j = 0 ; j < udata.length ; j++) {
					let u = udata[j];
					if (u.x == x && u.y == y) {
						return { country: c.fname, index: j };
					}
				}
			}
			return false;
		}

		this.setunit = function(x, y, cname, uname) {
			if (this.isinside(x, y)) {
				this.savedata.countrydata[cname].unitdata.push({ x: x, y: y, fname: uname });
			}
		}	

		this.deleteunit = function(cname, index) {
			if (!this.savedata.countrydata[cname].unitdata) {
				return;
			}
			this.savedata.countrydata[cname].unitdata.splice(index, 1);
		}

		this.setunitmap = function() {
			let unitmap = this.unitmap = [];
			for (let x = 0 ; x < this.savedata.mapdata.width ; x++) {
				unitmap[x] = [];
				for (let y = 0 ; y < this.savedata.mapdata.height ; y++) {
					unitmap[x][y] = null;
				}
			}
			for (let i = 0 ; i < Country.length ; i++) {
				let c = Country[i];
				if (c.npc) {
					continue;
				}
				let udata = this.savedata.countrydata[c.fname].unitdata;
				for (let j = 0 ; j < udata.length ; j++) {
					let u = udata[j];
					unitmap[u.x][u.y] = u.fname;
				}
			}
		}

		this.drawterrain = function(tname, dx, dy, x, y, c) {
			let ctx = this.ctx;
			let map = this.savedata.mapdata.map;
			let t = Terrain_imglist[tname];
			let t2;
			if (t.connect && c !== null) {
				if (tname == "wideriver") {
					t2 = Terrain_imglist["river" + c];
				}
				else {
					t2 = Terrain_imglist[tname + c];
				}
			}
			else {
				t2 = t;
			}
			if (x > 0 && t2.receiveshadow && Terrain_imglist[map[x - 1][y]].shadow) {
				ctx.drawImage(terrainimg[t2.imgdata.num][this.savedata.mapdata.maptype], t2.imgdata.sx * Sqsize, t2.imgdata.sy * Sqsize, Sqsize, t2.imgdata.height, dx, dy + Sqsize - t2.imgdata.height, Sqsize, t2.imgdata.height);
			}
			else {
				if (t2.large) {
					ctx.drawImage(terrainimg[t2.imgdata.num][this.savedata.mapdata.maptype], t2.imgdata.ix * Sqsize, t2.imgdata.iy * Sqsize, t2.imgdata.height, t2.imgdata.height, dx, dy, Sqsize, Sqsize);
				}
				else {
					ctx.drawImage(terrainimg[t2.imgdata.num][this.savedata.mapdata.maptype], t2.imgdata.ix * Sqsize, t2.imgdata.iy * Sqsize, Sqsize, t2.imgdata.height, dx, dy + Sqsize - t2.imgdata.height, Sqsize, t2.imgdata.height);
				}
			}
		}

		this.drawunit = function(uname, dx, dy, reversex) {
			let ctx = this.ctx;
			let u = Unit_imglist[uname];
			if (reversex) {
				ctx.save();
				ctx.scale(-1, 1);
				ctx.drawImage(unitimg[u.imgdata.num], u.imgdata.ix * Sqsize, u.imgdata.iy * Sqsize, Sqsize, Sqsize, -dx -Sqsize, dy, Sqsize, Sqsize);
				ctx.restore();
			}
			else {
				ctx.drawImage(unitimg[u.imgdata.num], u.imgdata.ix * Sqsize, u.imgdata.iy * Sqsize, Sqsize, Sqsize, dx, dy, Sqsize, Sqsize);
			}
		}

		this.drawmap = function() {
			for (let i = 1 ; i < Country.length ; i++) {
				let c = Country[i];
				let cnum = Countrynamenum[this.savedata.countrydata[c.fname].unitcountrytype];
				Terrain_imglist["hq_" + c.fname].imgdata.iy = cnum * 2;
				Unit_imglist["infantry_" + c.fname].imgdata.ix = Unit_imglist["infantry"].imgdata.ix + cnum;
				Unit_imglist["mech_" + c.fname].imgdata.ix = Unit_imglist["mech"].imgdata.ix + cnum;
			}

			let ctx = this.ctx;
			let map = this.savedata.mapdata.map;

			for (let y = 0 ; y < this.savedata.mapdata.height ; y++) {
				for (let x = 0 ; x < this.savedata.mapdata.width ; x++) {
					let tname = map[x][y];
					let t = Terrain_imglist[tname];
					let img;
					let c = 0;
					if (t.connect) {
						let count = 0;
						let dx = [ 0, 1, 0, -1 ];
						let dy = [ -1, 0, 1, 0 ];
						let di = [ 1, 3, 0, 2 ];
						let isshoal = [];
						for (let i = 0 ; i < 4 ; i++) {
							let x2 = x + dx[di[i]];
							let y2 = y + dy[di[i]];
							isshoal[di[i]] = false;
							if (this.isinside(x2, y2)) {
								let tname2 = map[x2][y2];
								let t2 = Terrain_imglist[tname2];
								if (tname2 == "shoal") {
									isshoal[di[i]] = true;
								}
								if ((tname == "road" && tname2 == "road") || 
										(tname == "bridge" && (tname2 == "bridge" || t2.land == true)) ||
										(tname == "river" && tname2 == "river") ||
										(tname == "wideriver" && (tname2 == "wideriver" || t2.sea)) ||
										(tname == "sea" && t2.land == true) ||
										(tname == "shoal" && t2.land == true && (tname2 != "river" && tname2 != "wideriver")) ||
										(t.pipe == true && t2.pipe == true && !(tname == "plain_pd" && tname2 == "plain_pd"))) {
									if (i >= 4) {
										if (tname == "river") {
											if (c & (1 << (i % 4)) || c & (1 << (i + 1) % 4)) {
												continue;
											}
										}
									}
									c += (1 << di[i]);
									count++;
								}
							}
							if (count == 2) {
								if (t.pipe == true) {
									if (tname == "pipe") {
										break;
									}
									else if (c == 10) {
										c = "h";
									}
									else if (c == 5) {
										c = "v";
									}
									else if (tname == "pipe_c") {
										map[x][y] = "pipe";
										tname = "pipe";
										t = Terrain_imglist["pipe"];
									}
									else if (tname == "plain_pd") {
										c = "";
									}
									break;
								}
							}
						}
						if (count == 0 && tname == "pipe") {
							c = 10;
						}
						if (count <= 1 && tname == "road") {
							if (c == 1 || c == 4) {
								c = 5;
							}
							else {
								c = 10;
							}
						}
						if (tname == "river" || tname == "wideriver" || tname == "sea") {
							if (tname == "river" || tname == "wideriver") {
								if (c == 0) {
									c = 10;
								}
								else if (count == 1) {
									if (c == 1 || c == 4) {
										c = 5;
									}
									else {
										c = 10;
									}
								}
							}
							if (!((tname == "river" || tname == "wideriver") && (c == 5 || c == 10))) {
								let dx = [ 0, 1, 1, 1, 0, -1, -1, -1 ];
								let dy = [ -1, -1, 0, 1, 1, 1, 0, -1 ];
								let island = [];
								let isriver = [];
								let issameriver = [];
								let ismouthriver = [];
								let issea = [];
								for (let i = 0 ; i < 8 ; i++) {
									let x2 = x + dx[i];
									let y2 = y + dy[i];
									island[i] = isriver[i] = issameriver[i] = ismouthriver[i] = issea[i] = false;
									if (this.isinside(x2, y2)) {
										let tname2 = map[x2][y2];
										let t2 = Terrain_imglist[tname2];
										if (t2.land == true) {
											island[i] = true;
										}
										if (t2.sea == true) {
											issea[i] = true;
										}
										if ((tname2 == "river" || tname2 == "wideriver") && (tname == "sea" || tname == tname2)) {
											if (tname2 == "river") {
												isriver[i] = true;
											}
											if (tname == tname2) {
												issameriver[i] = true;
											}
											if (tname2 != "wideriver" && (i == 0 || i == 4)) {
												y2 += dy[i];
												if (this.isinside(x2, y2) && map[x2][y2] == "river") {
													ismouthriver[i] = true;
												}
											}
											else {
												ismouthriver[i] = true;
											}
										}
									}
								}
								for (let i = 0 ; i < 8 ; i += 2) {
									if (tname == "sea" && ismouthriver[i] && (!isriver[i] || (!isriver[(i + 7) % 8] && !isriver[(i + 1) % 8])) && !island[(i + 2) % 8] && !island[(i + 3) % 8] && !island[(i + 4) % 8] && !island[(i + 5) % 8] && !island[(i + 6) % 8]) {
										c = "_r" + (1 << (i / 2));
										break;
									}
									if ((tname == "sea" && !island[i] && island[(i + 1) % 8] && !island[(i + 2) % 8]) ||
											((tname == "river" || tname =="wideriver") && issameriver[i] && (!issameriver[(i + 1) % 8] && !(tname == "wideriver" && issea[(i + 1) % 8])) && issameriver[(i + 2) % 8])) {
										c |= 1 << ((i / 2) + 4);
									}
								}
							}
						}
						if (count < 2 && tname == "pipe_c") {
							map[x][y] = "pipe";
							tname = "pipe";
							t = Terrain_imglist["pipe"];
							c = 10;
						}
						if (tname == "plain_pd" && count != 2) {
								c = "";
						}
						if (tname == "bridge") {
							if (c == 1 || c == 4 || c == 5) {
								c = "v";
							}
							else {
								c = "h";
							}
						}
						if (tname == "wideriver") {
							if (count == 4 && c != 255) {
								c = 15;
							}
						}
						if (tname == "shoal") {
							let dx = [ 1, 1, -1, -1 ];
							let dy = [ -1, 1, 1, -1 ];
							let island = [];
							for (let i = 0 ; i < 4 ; i++) {
								let x2 = x + dx[i];
								let y2 = y + dy[i];
								if (this.isinside(x2, y2) && Terrain_imglist[map[x2][y2]].land == true) {
									island[i] = true;
								}
								else {
									island[i] = false;
								}
							}
							let seaflag = false;
							if (c == 0 || c == 5 || c == 10 || c == 15) {
								seaflag = true;
							}
							for (let i = 0 ; i < 4 ; i++) {
								if (c == 1 << i && (island[(i + 1) % 4] == true || island[(i + 2) % 4] == true)) {
									seaflag = true;
									break;
								}
							}
							if (seaflag == true) {
								map[x][y] = "sea";
								t = Terrain_imglist["sea"];
								tname = "sea";
							}
							else {
								for (let i = 0 ; i < 4 ; i++) {
									if (c == 7 || c == 11 || c == 13 || c == 14) {
										continue;
									}
									if (c & (1 << i)) {
										if (isshoal[(i + 1) % 4] == true) {
											c |= 1 << (i + 4);
										}
										if (isshoal[(i + 3) % 4] == true) {
											c |= 1 << ((i + 3) % 4 + 4);
										}
									}
								}		
							}
						}
					}
					this.drawterrain(tname, x * Sqsize, y * Sqsize, x, y, c);

					let uname = this.unitmap[x][y];
					if (uname !== null) {
						this.drawunit(uname, x * Sqsize, y * Sqsize, this.savedata.countrydata[Unit_imglist[uname].country].unitdirection === "reverse");
					}
				}
			}
			if (this.select_mode == "Map" && this.resizedrag == true) {
				ctx.beginPath();
				ctx.strokeStyle = "black";
				ctx.lineWidth = 1;
				ctx.rect(0, 0, this.savedata.mapdata.width * Sqsize, this.savedata.mapdata.height * Sqsize);
				ctx.stroke();
			}

			let cx = Math.floor(this.mx / Sqsize);
			let cy = Math.floor(this.my / Sqsize);
			if (this.isinside(cx, cy)) {
				ctx.fillStyle = "black";
				ctx.font = "16px sans serif";
				ctx.fillText("(" + cx + "," + cy + ") " + this.select_terrain + "," + this.select_unitlock, this.tx + 100, 20);
				ctx.beginPath();
				ctx.strokeStyle = "rgba(0, 0, 0, 1)";
				ctx.rect(cx * Sqsize + 1, cy * Sqsize + 1, Sqsize - 2, Sqsize - 2);
				ctx.stroke();
			}
		}

		this.copymap = function(from, to) {
			for (let x = 0 ; x < this.savedata.mapdata.width ; x++) {
				to[x] = [];
				for (let y = 0 ; y < this.savedata.mapdata.height ; y++) {
					to[x][y] = from[x][y];
				}
			}
		}
		this.restoremap = function() {
			this.copymap(this.mapbeforedrag, this.savedata.mapdata.map);
		}
		this.backupmap = function() {
			this.copymap(this.savedata.mapdata.map, this.mapbeforedrag);
		}

		this.drawtool = function() {
			let ctx = this.ctx;
			let tx = this.tx;
			let ty = this.ty;
			if (this.select_mode === "Map") {
				ctx.drawImage(changesizeimg, (this.savedata.mapdata.width - 0.5) * Sqsize, (this.savedata.mapdata.height - 0.5) * Sqsize);
			}
		}

		this.draw = function() {
			let ctx = this.ctx;
			ctx.fillStyle = "rgb(240, 240, 240)";
			ctx.beginPath();
//			ctx.rect(0, 0, this.savedata.mapdata.width * Sqsize+ 8, this.canvas.height);
			ctx.rect(0, 0, this.canvas.width, this.canvas.height);
			ctx.fill();
			this.drawmap();
			if (this.usetool) {
				this.drawtool();
			}
		}

		this.isinside = function(x, y) {
			if (0 <= x && x < this.savedata.mapdata.width && 0 <= y && y < this.savedata.mapdata.height) {
				return true;
			}
			else {
				return false;
			}	
		}

		this.cansetriver = function(x, y) {
			let map = this.savedata.mapdata.map;
			let dx = [ 0, 0, -1, -1 ];
			let dy = [-1, 0, -1, 0 ];
			for (let i = 0 ; i < 4 ; i++) {
				let x2 = x + dx[i];
				let y2 = y + dy[i];
				let allriver = true;
				for (let dx2 = 0 ; dx2 <= 1 ; dx2++) {
					for (let dy2 = 0 ; dy2 <= 1 ; dy2++) {
						if (dx[i] + dx2 == 0 && dy[i] + dy2 == 0) {
							continue;
						}
						let x3 = x2 + dx2;
						let y3 = y2 + dy2;
						if (!this.isinside(x3, y3) || map[x3][y3] != "river") {
							allriver = false;
						}
					}
				}
				if (allriver == true) {
					return false;
				}
			}
			return true;
		}

		this.deletenearreef = function(x, y) {
			let map = this.savedata.mapdata.map;
			if (this.isinside(x, y)) {
				for (let dx = -1 ; dx <= 1 ; dx++) {
					for (let dy = -1 ; dy <= 1 ; dy++) {
						if (dx == 0 && dy == 0) {
							continue;
						}
						let x2 = x + dx;
						let y2 = y + dy;
						if (this.isinside(x2, y2) && map[x2][y2] == "reef") {
							map[x2][y2] = "sea";
						}
					}
				}
			}
		}

		this.changemap = function(x, y, tname) {
			let map = this.savedata.mapdata.map;
			if (this.isinside(x, y)) {
				let t = Terrain_imglist[map[x][y]];
				if (t.large == true) {
					for (let dx = 0 ; dx < t.size ; dx++) {
						for (let dy = 0 ; dy < t.size ; dy++) {
							let x2 = x - t.imgdata.x + dx;
							let y2 = y - t.imgdata.y + dy;
							if (t.land) {
								map[x2][y2] = "plain";
								this.deletenearreef(x2, y2);
							}
							else {
								map[x2][y2] = "sea";
							}
						}
					}
				}
				map[x][y] = tname;
				t = Terrain_imglist[tname];
				if (t.land == true) {
					this.deletenearreef(x, y);
				}
			}
		}

		this.setmap = function(x, y, tname, check) {
			let map = this.savedata.mapdata.map;
			check = check || false;
			retval = false;
			let t = Terrain_imglist[tname];
			if (this.isinside(x, y)) {
				if (tname == "pipe_c") {
					if (map[x][y] == "pipe" && 
						((this.isinside(x - 1, y) && map[x - 1][y] == "pipe" && this.isinside(x + 1, y) && map[x + 1][y] == "pipe") ||
						 (this.isinside(x, y - 1) && map[x][y - 1] == "pipe" && this.isinside(x, y + 1) && map[x][y + 1] == "pipe"))) {
							retval = true;
							if (!check) {
								this.changemap(x, y, tname);
							}
					}
				}
				else if (tname == "reef") {
					if (map[x][y] == "sea") {
						retval = true;
						if (!check) {
							this.changemap(x, y, tname);
							for (let dx = -1 ; dx <= 1 ; dx++) {
								for (let dy = -1 ; dy <= 1 ; dy++) {
									if (dx == 0 && dy == 0) {
										continue;
									}
									let x2 = x + dx;
									let y2 = y + dy;
									if (this.isinside(x2, y2) && Terrain_imglist[map[x2][y2]].sea != true) {
										this.changemap(x2, y2, "sea");
									}
								}
							}
						}
					}
				}
				else if (tname == "shoal") {
					if (map[x][y] == "sea") {
						retval = true;
						if (!check) {
							this.changemap(x, y, tname);
						}
					}
				}
				else if (tname == "river" || tname == "wideriver") {
					if (tname == "wideriver" || this.cansetriver(x, y)) {
						retval = true;
						if (!check) {
							this.changemap(x, y, tname);
						}
					}
				}
				else if (t.hq == true && t.country != "no") {
					retval = true;
					if (!check) {
						for (let x2 = 0; x2 < this.savedata.mapdata.width ; x2++) {
							for (let y2 = 0 ; y2 < this.savedata.mapdata.height ; y2++) {
								let t2 = Terrain_imglist[map[x2][y2]];
								if (t2.hq == true && t.country == t2.country) {
									this.changemap(x2, y2, "plain");
								}
							}
						}
						this.changemap(x, y, tname);
					}
				}
				else if (t.large) {
					if (x + t.size - 1 < this.savedata.mapdata.width && y + t.size - 1 < this.savedata.mapdata.height) {
						retval = true;
						if (!check) {
							for (let dy = 0 ; dy < t.size ; dy++) {
								for (let dx = 0 ; dx < t.size ; dx++) {
									this.changemap(x + dx, y + dy, tname + dx + "" + dy);
								}
							}
						}
					}
				}
				else {
					retval = true;
					if (!check) {
						this.changemap(x, y, tname);
					}
				}
			}
			return retval;
		}

		this.setcanvas = function() {
			this.canvas.width = Sqsize * this.savedata.mapdata.width;
			this.canvas.height = Sqsize * this.savedata.mapdata.height + 16;
			if (this.usetool) {
				this.UI_Base.x = this.canvas.width + 8;
				this.UI_Base.update();
				this.canvas.width += Toolwidth + 8;
				if (this.canvas.height < Toolheight) {
					this.canvas.height = Toolheight;
				}
			}

			this.tx = Sqsize * this.savedata.mapdata.width;
			this.ty = 0;
		}

		this.init = function(w, h, clear) {
			this.setsize(w, h, clear);
			this.setcanvas();
		}

		this.savedata.mapdata = {
			width:		Defaultwidth,
			height:		Defaultheight,
			maptype:	0,
			map:			[],
		};

		this.savedata.countrydata = {};
		for (let i = 0 ; i < Country.length ; i++) {
			let c = Country[i];
			if (c.npc) {
				continue;
			}
			this.savedata.countrydata[c.fname] = {
				front: {
					shogun:	null,
					bp:			0
				},
				back:	{
					shogun: null,
					bp:			0
				},
				money: 0,
				unitdirection:	"normal",
				unitcountrytype: c.fname,
				unitdata: [],
			}
		}

		this.debug_style = null;//{ lineWidth: 1 };

		this.Button_new = UI_Button({
			width:			30,
			height:			30,
			data:				UI_Drawdata_Image({
										width:			30,
										height:			30,
										src: "image/button/new.png",
										moverstyle:	{ fillStyle: "#cccccc" },
									})
		});
		this.Button_new.onmousedown = function(evt) {
			this.init(this.savedata.mapdata.width, this.savedata.mapdata.height, true);
			this.draw();
		}
		this.Button_open = UI_Button({
			width:			30,
			height:			30,
			data:				UI_Drawdata_Image({
										width:			30,
										height:			30,
										src: "image/button/open.png",
										moverstyle:	{ fillStyle: "#cccccc" },
									})
		});
		this.Button_open.onmousedown = function(evt) {
			let input = document.createElement("input");
			input.type = "file"
			input.me = this;
			input.onchange = function(e) {
				let me = this.me;
				let map = me.savedata.mapdata.map;
				if (this.files.length > 0){
					let f = this.files[0];
					let reader = new FileReader();
					reader.me = me;
					reader.onload = (function(file) {
						let me = this.me;
						let loaddata = JSON.parse(file.target.result);
						if (loaddata && loaddata.fwmapdataver) {
							if (loaddata.fwmapdataver == 1) {
								me.savedata.fwmapdataver = 2;
								me.savedata.mapdata.width = loaddata.width;
								me.savedata.mapdata.height = loaddata.height;
								me.savedata.mapdata.maptype = 0;
								me.init(me.savedata.mapdata.width, me.savedata.mapdata.height, true);
								let map = me.savedata.mapdata.map = loaddata.map;
								for (let i = 0 ; i < Country.length - 1 ; i++) {
									let c = Country[i];
									if (c.npc) {
										continue;
									}
									if (loaddata.unitdata !== undefined) {
										me.savedata.countrydata[c.fname].unitdata = loaddata.unitdata[c.fname];
									}
									else {
										me.savedata.countrydata[c.fname].unitdata = [];
									}
								}
							}
							else {
								me.savedata = loaddata;
								me.init(me.savedata.mapdata.width, me.savedata.mapdata.height, false);
							}
							me.setunitmap();
							me.draw();
							me.select_mode = "Terrain";
							me.UI_Base.paint();
						}
						else {
							alert("ファイルの形式が違います");
						}
					});
					reader.readAsText(f);	
				}
			}
			input.click();
		}

		this.Button_save = UI_Button({
			width:			30,
			height:			30,
			data:				UI_Drawdata_Image({
										width:			30,
										height:			30,
										src: "image/button/save.png",
										moverstyle:	{ fillStyle: "#cccccc" },
									}),
		});
		this.Button_save.onmousedown = function(evt) {
			let blob = new Blob([JSON.stringify(this.savedata, null, ' ')], {type: "application/json"});
			let a = document.createElement("a");
			a.href = URL.createObjectURL(blob);
			document.body.appendChild(a);
			a.target = "_blank";
			a.download = "save.json";
			a.click();
			document.body.removeChild(a);
		}


		this.Selector_Mode_style =					{ fillStyle: "white", lineWidth: 1, align: "center" };
		this.Selector_Mode_moverstyle =		{ fillStyle: "white", lineWidth: 2, align: "center" };
		this.Selector_Mode_offstyle =			{ fillStyle: "lightgray", lineWidth: 1, align: "center" };
		this.Selector_Mode_moveroffstyle =	{ fillStyle: "lightgray", lineWidth: 2, align: "center" };
		this.Selector_Mode = UI_Selector({
			position:		"newline",
			y:					30,
			width:			200,
			height:			25,
			selectnum:	0,
			bindvar:		"this.arg.select_mode",
			data:	[
				UI_Drawdata_Text({
					text:						"Terrain",
					id:							"Terrain",
					width:					50,
					height:					25,
					style:					this.Selector_Mode_style,
					moverstyle:			this.Selector_Mode_moverstyle,
					offstyle:				this.Selector_Mode_offstyle,
					moveroffstyle:	this.Selector_Mode_moveroffstyle,
				}),
//				UI_Drawdata_Text({
//					text:					"Extra",
//					id:						"Extra",
//					width:				50,
//					height:				25,
//					style:				this.Selector_Mode_style,
//					moverstyle:		this.Selector_Mode_moverstyle,
//					offstyle:				this.Selector_Mode_offstyle,
//					moveroffstyle:	this.Selector_Mode_moveroffstyle,
//				}),
//				UI_Drawdata_Text({
//					text:					"Extra2",
//					id:						"Extra2",
//					width:				50,
//					height:				25,
//					style:				this.Selector_Mode_style,
//					moverstyle:		this.Selector_Mode_moverstyle,
//					offstyle:				this.Selector_Mode_offstyle,
//					moveroffstyle:	this.Selector_Mode_moveroffstyle,
//				}),
				UI_Drawdata_Text({
					text:					"Unit",
					id:					"Unit",
					width:				50,
					height:				25,
					style:				this.Selector_Mode_style,
					moverstyle:		this.Selector_Mode_moverstyle,
					offstyle:				this.Selector_Mode_offstyle,
					moveroffstyle:	this.Selector_Mode_moveroffstyle,
				}),
				UI_Drawdata_Text({
					text:					"Map",
					id:					"Map",
					width:				50,
					height:				25,
					style:				this.Selector_Mode_style,
					moverstyle:		this.Selector_Mode_moverstyle,
					offstyle:				this.Selector_Mode_offstyle,
					moveroffstyle:	this.Selector_Mode_moveroffstyle,
				}),
			],
		});


		this.Selector_Terrain_Mode = UI_Selector({
			position:				"newline",
			y:							0,
			width:					200,
			height:					25,
			selectnum:	0,
			bindvar:	"this.arg.select_terrain_mode",
			data:	[
				UI_Drawdata_Text({
					text:						"Normal",
					id:							"Normal",
					width:					50,
					height:					25,
					style:					this.Selector_Mode_style,
					moverstyle:			this.Selector_Mode_moverstyle,
					offstyle:				this.Selector_Mode_offstyle,
					moveroffstyle:	this.Selector_Mode_moveroffstyle,
				}),
				UI_Drawdata_Text({
					text:						"Land",
					id:							"Land",
					width:					50,
					height:					25,
					style:					this.Selector_Mode_style,
					moverstyle:			this.Selector_Mode_moverstyle,
					offstyle:				this.Selector_Mode_offstyle,
					moveroffstyle:	this.Selector_Mode_moveroffstyle,
				}),
				UI_Drawdata_Text({
					text:						"Sea",
					id:							"Sea",
					width:					50,
					height:					25,
					style:					this.Selector_Mode_style,
					moverstyle:			this.Selector_Mode_moverstyle,
					offstyle:				this.Selector_Mode_offstyle,
					moveroffstyle:	this.Selector_Mode_moveroffstyle,
				}),

			],
		});

		var create_drawdata_image = function(data, i, a) {
			if (data.type === "imgsp") {
				let t = Terrain_imglist[data.name];
				let timg = t.imgdata;
				imgdat =	UI_Drawdata_Image({
						width:					24,
						height:					24,
						imagewidth:			16,
						imageheight:		(t.large) ? 16 : timg.height,
						position:				this.position,
						x:							this.x,
						y:							this.y,
						id:							data.name,
						param:					terrainimg[timg.num],
						imagesrcx:			timg.ix * 16,
						imagesrcy:			timg.iy * 16,
						imagesrcw:			(t.large) ? timg.height : 16,
						imagesrch:			timg.height,
						style:					Selector_Terrain_style,
						moverstyle:			Selector_Terrain_moverstyle,
						offstyle:				Selector_Terrain_offstyle,
						moveroffstyle	:	Selector_Terrain_moveroffstyle,
				});
				this.stdata.push(imgdat);
				if (data.name.substr(0, 3) === "hq_") {
					this.stdatahq[data.name.substr(3, 2)] = imgdat;
				}
				this.position = "static";
				this.x = this.y = 0;
			}
			else if (data.type === "imgsp2") {
				let t = Unit_imglist[data.name].imgdata;
				imgdat =	UI_Drawdata_Image({
					width:					24,
					height:					24,
					imagewidth:			16,
					imageheight:		t.height,
					position:				this.position,
					x:							this.x,
					y:							this.y,
					id:							data.name,
					image:					unitimg[t.num],
					imagesrcx:			t.ix * 16,
					imagesrcy:			t.iy * 16,
					imagesrcw:			16,
					imagesrch:			t.height,
					style:					Selector_Terrain_style,
					moverstyle:			Selector_Terrain_moverstyle,
					offstyle:				Selector_Terrain_offstyle,
					moveroffstyle	:	Selector_Terrain_moveroffstyle,
				});
				this.stdata.push(imgdat);
				if (data.name.substr(0, 8) === "infantry") {
					this.stdatainf[data.name.substr(9, 2)] = imgdat;
				}
				if (data.name.substr(0, 4) === "mech") {
					this.stdatamech[data.name.substr(5, 2)] = imgdat;
				}
				this.position = "static";
				this.x = this.y = 0;
			}
			else if (data.type === "img") {
				imgdat =	UI_Drawdata_Image({
					width:					24,
					height:					24,
					imagewidth:			16,
					imageheight:		16,
					position:				this.position,
					x:							this.x,
					y:							this.y,
					id:							data.name,
					src:						data.src,
					style:					Selector_Terrain_style,
					moverstyle:			Selector_Terrain_moverstyle,
					offstyle:				Selector_Terrain_offstyle,
					moveroffstyle	:	Selector_Terrain_moveroffstyle,
				});
				this.stdata.push(imgdat);
				this.position = "static";
				this.x = this.y = 0;
			}
			else if (data.type === "newline") {
				this.position = "newline";
				this.x = 0;
				this.y = 0;
				if (data.x) {
					this.x = data.x;
				}
				if (data.y) {
					this.y = data.y;
				}
			}
			else if (data.type === "space") {
				if (this.position !== "newline") {
					this.position = "relative";
				}
				if (data.x) {
					this.x += data.x;
				}
				if (data.y) {
					this.y += data.y;
				}
			}
		}
		let Selector_Terrain_style =					{	lineWidth: 0, strokeStyle: "black", align: "center", valign: "bottom", py: 4, fillStyle: "gray" };
		let Selector_Terrain_moverstyle =			{	lineWidth: 1, strokeStyle: "black", align: "center", valign: "bottom", py: 3, fillStyle: "gray" };
		let Selector_Terrain_offstyle =				{	lineWidth: 0, strokeStyle: "black", align: "center", valign: "bottom", py: 4 };
		let Selector_Terrain_moveroffstyle =	{	lineWidth: 1, strokeStyle: "black", align: "center", valign: "bottom", py: 3 };
		this.Selector_Terrain_data = [];
		this.Selector_Terrain_datahq = {};
		{
			let imgdat;
			let stdata = this.Selector_Terrain_data;
			let stdatahq = this.Selector_Terrain_datahq;
			let arg = {
				position:	"static",
				x:				0,
				y:				0,
				stdata:		stdata,
				stdatahq:	stdatahq,
			};
			TerrainUI_data.forEach(create_drawdata_image, arg);
		}

		this.Selector_Terrain = UI_Selector({
			position:			"absolute",
			x:						0,
			y:						0,
			width:				0,
			height:				0,
			space:				6,
			lineheight:		30,
			px:						6,
			bindvar:			"this.arg.select_terrain",
			enablewheel:	true,
			data:					this.Selector_Terrain_data,
			style:				this.debug_style,
			preprocess:		function() {
											let th = this.arg;
											this.data.forEach(function(data, i, a) {
												data.image = data.param[th.savedata.mapdata.maptype];
											});
										},
		});

		let Selector_Terrain_Country_style =					{	lineWidth: 0, strokeStyle: "black", align: "center", valign: "bottom", py: 4 };
		let Selector_Terrain_Country_moverstyle =			{	lineWidth: 1, strokeStyle: "black", align: "center", valign: "bottom", py: 3 };

		this.Button_Terrain_Country = [];
		this.Button_Terrain_Countryimage = [];
		for (let i = 1 ; i < Country.length ; i++) {
			this.Button_Terrain_Countryimage[i - 1] = [];
			for (let j = 1 ; j < Country.length ; j++) {
				this.Button_Terrain_Countryimage[i - 1][j - 1] = UI_Drawdata_Image({
					width:			24,
					height:			24,
					id:					Country[j].fname,
					src: 				"image/button/" + Country[j].fname + ".png",
					style:			Selector_Terrain_Country_style,
					moverstyle:	Selector_Terrain_Country_moverstyle,
				})
			}
		}
		for (let i = 1 ; i < Country.length ; i++) {
			this.Button_Terrain_Country[i - 1] = UI_ClickSelector({
				width:			24,
				height:			24,
				position:		"newline",
				x:					6,
				y:					30,
				selectnum:	i - 1,
				id:					Country[i].fname,
				bindvar:		"this.arg.savedata.countrydata[this.id].unitcountrytype",
				data:				[ this.Button_Terrain_Countryimage[i - 1][0],
											this.Button_Terrain_Countryimage[i - 1][1],
											this.Button_Terrain_Countryimage[i - 1][2],
											this.Button_Terrain_Countryimage[i - 1][3],
											this.Button_Terrain_Countryimage[i - 1][4],
										],
				preprocess:		function() {
											this.arg.Selector_Terrain_datahq[this.id].imagesrcy = this.selectnum * 32;
											this.arg.Selector_Unit_datainf[this.id].imagesrcx = this.selectnum * 16;
											this.arg.Selector_Unit_datamech[this.id].imagesrcx = this.selectnum * 16 + 80;
											this.arg.ClickSelector_Unit_datainf[this.id][0].imagesrcx = this.selectnum * 16;
											this.arg.ClickSelector_Unit_datainf[this.id][1].imagesrcx = this.selectnum * 16;
										}
			});
		}

		this.Container_Terrain_Country = UI_Container({
			x:				0,
			y:				70,
			position:	"absolute",
			style:		this.debug_style,
			data:			[
									this.Button_Terrain_Country[0],
									this.Button_Terrain_Country[1],
									this.Button_Terrain_Country[2],
									this.Button_Terrain_Country[3],
									this.Button_Terrain_Country[4],
								],
		});

		this.Container_Terrain_Normal = UI_Container({
			id:					"Normal",
			style:			this.debug_style,
			position:		"absolute",
			y:					35,
			data:				[
										this.Container_Terrain_Country,
										this.Selector_Terrain,
									],
		});

		this.Selector_Terrain_Land_data = [];
		{
			let imgdat;
			let stdata = this.Selector_Terrain_Land_data;
			let arg = {
				position:	"static",
				x:				0,
				y:				0,
				stdata:		stdata,
			};
			Terrain_Land_UI_data.forEach(create_drawdata_image, arg);
		}

		this.Selector_Terrain_Land = UI_Selector({
			width:				0,
			height:				0,
			space:				6,
			lineheight:		30,
			px:						6,
			bindvar:			"this.arg.select_terrain",
			enablewheel:	true,
			data:					this.Selector_Terrain_Land_data,
			style:				this.debug_style,
			preprocess:		function() {
											let th = this.arg;
											this.data.forEach(function(data, i, a) {
												data.image = data.param[th.savedata.mapdata.maptype];
											});
										},
		});

		this.Container_Terrain_Land = UI_Container({
			id:					"Land",
			position:		"absolute",
			y:					35,
			style:			this.debug_style,
			data:				[
										this.Selector_Terrain_Land,
									],
		});

		this.Selector_Terrain_Sea_data = [];
		{
			let imgdat;
			let stdata = this.Selector_Terrain_Sea_data;
			let arg = {
				position:	"static",
				x:				0,
				y:				0,
				stdata:		stdata,
			};
			Terrain_Sea_UI_data.forEach(create_drawdata_image, arg);
		}

		this.Selector_Terrain_Sea = UI_Selector({
			width:				0,
			height:				0,
			space:				6,
			lineheight:		30,
			px:						6,
			bindvar:			"this.arg.select_terrain",
			enablewheel:	true,
			data:					this.Selector_Terrain_Sea_data,
			style:				this.debug_style,
			preprocess:		function() {
											let th = this.arg;
											this.data.forEach(function(data, i, a) {
												data.image = data.param[th.savedata.mapdata.maptype];
											});
										},
		});

		this.Container_Terrain_Sea = UI_Container({
			id:					"Sea",
			position:		"absolute",
			y:					35,
			style:			this.debug_style,
			data:				[
										this.Selector_Terrain_Sea,
									],
		});

		this.Selector_Terrain_Shoal_data = [];
		{
			let imgdat;
			let stdata = this.Selector_Terrain_Shoal_data;
			let arg = {
				position:	"static",
				x:				0,
				y:				0,
				stdata:		stdata,
			};
			Terrain_Shoal_UI_data.forEach(create_drawdata_image, arg);
		}

		this.Selector_Terrain_Shoal = UI_Selector({
			width:				0,
			height:				0,
			space:				6,
			lineheight:		30,
			px:						6,
			bindvar:			"this.arg.select_terrain",
			enablewheel:	true,
			data:					this.Selector_Terrain_Shoal_data,
			style:				this.debug_style,
			preprocess:		function() {
											let th = this.arg;
											this.data.forEach(function(data, i, a) {
												data.image = data.param[th.savedata.mapdata.maptype];
											});
										},
		});

		this.Container_Terrain_Shoal = UI_Container({
			id:					"Shoal",
			position:		"absolute",
			y:					35,
			style:			this.debug_style,
			data:				[
										this.Selector_Terrain_Shoal,
									],
		});

		this.Selector_Terrain_River_data = [];
		{
			let imgdat;
			let stdata = this.Selector_Terrain_River_data;
			let arg = {
				position:	"static",
				x:				0,
				y:				0,
				stdata:		stdata,
			};
			Terrain_River_UI_data.forEach(create_drawdata_image, arg);
		}

		this.Selector_Terrain_River = UI_Selector({
			width:				0,
			height:				0,
			space:				6,
			lineheight:		30,
			px:						6,
			bindvar:			"this.arg.select_terrain",
			enablewheel:	true,
			data:					this.Selector_Terrain_River_data,
			style:				this.debug_style,
			preprocess:		function() {
											let th = this.arg;
											this.data.forEach(function(data, i, a) {
												data.image = data.param[th.savedata.mapdata.maptype];
											});
										},
		});

		this.Container_Terrain_River = UI_Container({
			id:					"River",
			position:		"absolute",
			y:					35,
			style:			this.debug_style,
			data:				[
										this.Selector_Terrain_River,
									],
		});

		this.Container_Terrain_Container = UI_Container({
			position:		"newline",
			x: 					0,
			y:					0,
			bindvar:		"this.arg.select_terrain_mode",
			style:			this.debug_style,
			data:				[
										this.Container_Terrain_Normal,
										this.Container_Terrain_Land,
										this.Container_Terrain_Sea,
									],
		});

		this.Container_Terrain = UI_Container({
			id:					"Terrain",
			style:			this.debug_style,
			position:		"absolute",
//			bindvar:		"this.select_terrain_mode",
			data:				[
										this.Selector_Terrain_Mode,
										this.Container_Terrain_Container,
									],
		});

		this.Selector_Unit_Country_image = [];
		for (let i = 1 ; i < Country.length ; i++) {
			this.Selector_Unit_Country_image[i - 1] = UI_Drawdata_Image({
				width:			24,
				height:			24,
				id:					Country[i].fname,
				src: 				"image/button/" + Country[i].fname + ".png",
				style:					Selector_Terrain_style,
				moverstyle:			Selector_Terrain_moverstyle,
				offstyle:				Selector_Terrain_offstyle,
				moveroffstyle	:	Selector_Terrain_moveroffstyle,
			});
		}

		this.Selector_Unit_Country = UI_Selector({
			space:			6,
			px:					6,
			width:			24,
			height:			24,
			style:			this.debug_style,
			selectnum:	0,
			id:					"unit_country",
			bindvar:		"this.arg.select_unitcountry",
			data:				this.Selector_Unit_Country_image,
		});

		this.ClickSelector_Unitlock = UI_ClickSelector({
			position:		"absolute",
			x:					180,
			y:					0,
			style:			this.debug_style,
			selectnum:	0,
			bindvar:		"this.arg.select_unitlock",
			data:				[ 
				UI_Drawdata_Image({
					width:					24,
					height:					24,
					imagewidth:			16,
					id:							"lock",
					imageheight:		16,
					src:						"image/button/lock.png",
					style:					Selector_Terrain_Country_style,
					moverstyle:			Selector_Terrain_Country_moverstyle,
				}),
				UI_Drawdata_Image({
					width:					24,
					height:					24,
					imagewidth:			16,
					id:							"unlock",
					imageheight:		16,
					src:						"image/button/unlock.png",
					style:					Selector_Terrain_Country_style,
					moverstyle:			Selector_Terrain_Country_moverstyle,
				}),
			],
		});

		this.ClickSelector_Unit_Direction = [];
		this.ClickSelector_Unit_datainf = {};

		for (let i = 1 ; i < Country.length ; i++) {
			let t = Unit_imglist["infantry_" + Country[i].fname].imgdata;
			this.ClickSelector_Unit_Direction[i - 1] = UI_ClickSelector({
				width:			30,
				height:			30,
				selectnum:	0,
				bindvar:		"this.arg.savedata.countrydata['" + Country[i].fname + "'].unitdirection",
				data:				[
					UI_Drawdata_Image({
						width:					24,
						height:					24,
						imagewidth:			16,
						imageheight:		16,
						id:							"normal",
						image:					unitimg[t.num],
						imagesrcx:			t.ix * 16,
						imagesrcy:			t.iy * 16,
						imagesrcw:			16,
						imagesrch:			16,
						style:					Selector_Terrain_Country_style,
						moverstyle:			Selector_Terrain_Country_moverstyle,
					}),
					UI_Drawdata_Image({
						width:					24,
						height:					24,
						imagewidth:			16,
						imageheight:		16,
						id:							"reverse",
						image:					unitimg[t.num],
						imagesrcx:			t.ix * 16,
						imagesrcy:			t.iy * 16,
						imagesrcw:			16,
						imagesrch:			16,
						transform:			"reversex",
						style:					Selector_Terrain_Country_style,
						moverstyle:			Selector_Terrain_Country_moverstyle,
					}),
				],
			});
			this.ClickSelector_Unit_datainf[Country[i].fname] = [ 
				this.ClickSelector_Unit_Direction[i - 1].data[0],
				this.ClickSelector_Unit_Direction[i - 1].data[1],
			];
		}

		this.Container_Unit_Direction = UI_Container({
			px:				6,
			space:		6,
			position:	"newline",
			y:				30,
			style:		this.debug_style,
			data:			[
									this.ClickSelector_Unit_Direction[0],
									this.ClickSelector_Unit_Direction[1],
									this.ClickSelector_Unit_Direction[2],
									this.ClickSelector_Unit_Direction[3],
									this.ClickSelector_Unit_Direction[4],
								],
		});

		this.Selector_Unit_image = [];
		this.Selector_Unit_datainf = {};
		this.Selector_Unit_datamech = {};

		for (let i = 1 ; i < Country.length ; i++) {
			let stdata = this.Selector_Unit_image[i - 1] = [];
			let stdatainf = this.Selector_Unit_datainf;
			let stdatamech = this.Selector_Unit_datamech;
			let arg = {
				position:	"static",
				x:					0,
				y:					0,
				stdata:			stdata,
				stdatainf:	stdatainf,
				stdatamech:	stdatamech,
			};
			let imgdat;
			UnitUI_data[Country[i].fname].forEach(create_drawdata_image, arg);
		}

		this.Selector_Unit = [];
		for (let i = 1 ; i < Country.length ; i++) {
			this.Selector_Unit[i - 1] = UI_Selector({
				position:			"absolute",
				y:						0,
				space:				6,
				lineheight:		30,
				px:						6,
				id:						Country[i].fname,
				bindvar:			"this.arg.select_unit",
				enablewheel:	true,
				data:					this.Selector_Unit_image[i - 1],
				style:				this.debug_style,
				preprocess:		function() {
												let th = this;
												this.data.forEach(function(data, i, a) {
													data.transform = (th.arg.savedata.countrydata[th.id].unitdirection === "reverse" && data.id !== "delete") ? "reversex" : null;
												});
											},
			});
		}

		this.Container_Unitlist = UI_Container({
			id:					"Unit",
			position:		"newline",
			y:					40,
			bindvar:		"this.arg.select_unitcountry",
			data:				[
										this.Selector_Unit[0],
										this.Selector_Unit[1],
										this.Selector_Unit[2],
										this.Selector_Unit[3],
										this.Selector_Unit[4],
									],
		});

		this.Container_Unit = UI_Container({
			id:					"Unit",
			position:		"absolute",
			style:			this.debug_style,
			data:				[
										this.Selector_Unit_Country,
										this.ClickSelector_Unitlock,
										this.Container_Unit_Direction,
										this.Container_Unitlist
									],
		});

		this.Container_Mapsize = UI_Container({
			px:					0,
			style:			this.debug_style,
			data:				[
										UI_Button({
											px: 2,
											py: 2,
											data:				UI_Drawdata_Text({
												width:		50,
												height:		20,
												text:			"size",
											}),
										}),
										UI_NumberBox({
											style:			{ fillStyle: "white", lineWidth: 1 },
											moverstyle:	{ fillStyle: "white", lineWidth: 2 },
											px: 2,
											py: 2,
											msg:				"width（1-100）",
											min:					1,
											max:					100,
											numtype:			"integer",
											enablewheel:	"mouseover",
											wheelnum:			1,
											bindvar:		"this.arg.savedata.mapdata.width",
											data:				UI_Drawdata_Text({
												width:			50,
												height:			20,
												style:			{ fillStyle: "white", align: "right", px: 3 },
											}),
											onchange:	function() {
												let num = Math.floor(+this.newvalue);
												if (num <= 0 || num > Maxwidth) {
													alert("width must be within 1-100.");
													return false;
												}
												if (this.num != this.arg.savedata.mapdata.width) {
													this.arg.init(num, this.arg.savedata.mapdata.height, false);
													this.arg.draw();
												}
												return true;
											},
										}),
										UI_Button({
											px: 2,
											py: 2,
											data:				UI_Drawdata_Text({
												width:		30,
												height:		20,
												text:			"×",
												style:		{ align: "center" },
											}),
										}),
										UI_NumberBox({
											px: 2,
											py: 2,
											msg:					"height（1～100）",
											style:				{ fillStyle: "white", lineWidth: 1 },
											moverstyle:		{ fillStyle: "white", lineWidth: 2 },
											msg:					"height（1-100）",
											min:					1,
											max:					100,
											numtype:			"integer",
											enablewheel:	"mouseover",
											wheelnum:			1,
											bindvar:			"this.arg.savedata.mapdata.height",
											data:					UI_Drawdata_Text({
												width:			50,
												height:			20,
												style:			{ fillStyle: "white", align: "right", px: 3 },
											}),
											onchange:	function(text) {
												let num = Math.floor(this.newvalue);
												if (num <= 0 || num > Maxwidth) {
													alert("height must be within 1-100.");
													return false;
												}
												if (this.num != this.arg.savedata.mapdata.height) {
													this.arg.init(this.arg.savedata.mapdata.width, num, false);
													this.arg.draw();
												}
												return true;
											},
										}),
									],
		});

		this.Container_Tileset = UI_Container({
			px:					0,
			position:		"newline",
			style:			this.debug_style,
			data:				[
										UI_Button({
											px: 2,
											py: 2,
											data:				UI_Drawdata_Text({
												width:		50,
												height:		20,
												text:			"Tileset",
											}),
										}),
										UI_ClickSelector({
											style:			{ fillStyle: "white", lineWidth: 1 },
											moverstyle:	{ fillStyle: "white", lineWidth: 2 },
											px: 2,
											py: 2,
											bindvar:		"this.arg.savedata.mapdata.maptype",
											enablewheel:	"mouseover",
											data:				[	
												UI_Drawdata_Text({
													width:			70,
													height:			20,
													text:				"Normal",
													id:					0,
													style:			{ px: 5 },
												}),
												UI_Drawdata_Text({
													width:			70,
													height:			20,
													text:				"Wasteland",
													id:					1,
													style:			{ px: 5 },
												}),
												UI_Drawdata_Text({
													width:			70,
													height:			20,
													text:				"Desert",
													id:					2,
													style:			{ px: 5 },
												}),
												UI_Drawdata_Text({
													width:			70,
													height:			20,
													text:				"Snow",
													id:					3,
													style:			{ px: 5 },
												}),
											],
											onchange: function() {
												this.arg.draw();
											},
										}),
									],
		});

		this.Container_Map = UI_Container({
			id:					"Map",
			position:		"absolute",
			lineheight:	30,
			data:				[
										this.Container_Mapsize,
										this.Container_Tileset,
									],
		});

		this.Container_Toolmain = UI_Container({
			position:		"newline",
			x: 					0,
			y:					30,
			bindvar:		"this.arg.select_mode",
			style:			this.debug_style,
			data:				[
										this.Container_Terrain,
										this.Container_Unit,
										this.Container_Map,
									],
		});

		this.UI_Base = UI_Base({
			arg: this,
			ctx: this.ctx,
			canvas: this.canvas,
			data: [
				this.Button_new,
				this.Button_open,
				this.Button_save,
				this.Selector_Mode,
				this.Container_Toolmain,
			],
		});

		this.init(this.savedata.mapdata.width, this.savedata.mapdata.height, true);

		this.select_mode = "Terrain";
		this.select_terrain_mode = "Normal";
		this.select_terrain = "plain";
		this.select_unitcountry = "rs";
		this.select_unit = "infantry_rs";
		this.select_unitlock = "lock";

		this.draw();
		this.UI_Base.paint();
	}
	return FWEditor;
}());
